import { ContractSpec } from '..';
import { AssembledTransaction } from './assembled_transaction';
import type { ContractClientOptions } from './types';
export declare class ContractClient {
    readonly spec: ContractSpec;
    readonly options: ContractClientOptions;
    /**
     * Generate a class from the contract spec that where each contract method
     * gets included with an identical name.
     *
     * Each method returns an {@link AssembledTransaction} that can be used to
     * modify, simulate, decode results, and possibly sign, & submit the
     * transaction.
     */
    constructor(spec: ContractSpec, options: ContractClientOptions);
    txFromJSON: <T>(json: string) => AssembledTransaction<T>;
}
